/* @author jlejeune */

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.BooleanWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.SequenceFile.CompressionType;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.*;
import org.apache.hadoop.mapreduce.lib.input.*;
import org.apache.hadoop.mapreduce.lib.output.*;
import org.apache.hadoop.util.GenericOptionsParser;


public class MyPiEstimator {

	public static void main(String[] args) throws Exception {
		Configuration conf = new Configuration();
		conf.setBoolean("mapred.map.tasks.speculative.execution", false);
		conf.setBoolean("mapred.reduce.tasks.speculative.execution", false);

		String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
		if (otherArgs.length != 3) {
			System.err.println("Usage: Pi <nMaps> <nReduce> <nSample>");
			System.exit(2);
		}
		
		//Parsing parameters
		final int numMap = Integer.parseInt(otherArgs[0]);
		final int numReduce = Integer.parseInt(otherArgs[1]);
		final long numSamples = Long.parseLong(otherArgs[2]);

		//Configuring the Job
		Job job = new Job(conf, "Pi_calulator");
		job.setInputFormatClass(/*A DEFINE*/);
		
		job.setMapOutputKeyClass(/*A DEFINE*/);//key output type maps
		job.setMapOutputValueClass(/*A DEFINE*/);//output value of such maps
		
		
		job.setOutputKeyClass(/*A DEFINE*/);//key output type MapReduce
		job.setOutputValueClass(/*A DEFINE*/);//output value of MapReduce types
		
		
		job.setOutputFormatClass(/*A DEFINE*/);

		job.setMapperClass(/*A DEFINE*/);
		// CAUTION: Do not use this method to avoid the bp compatibility with the types of key/value
		//job.setCombinerClass(MyPiReducer.class); 
		job.setReducerClass(/*A DEFINE*/);
		job.setNumReduceTasks(numReduce);
		job.setJarByClass(MyPiEstimator.class); 
				
		Path TMP_DIR = new Path("/TMP_PI");
		final Path inDir = new Path(TMP_DIR, "in");// path to the directory entry
		final Path outDir = new Path(TMP_DIR, "out");// path to the output directory
		FileInputFormat.addInputPath(job,inDir);//declaration of a directory entry 
		FileOutputFormat.setOutputPath(job, outDir);//declaration of output directory
		// Recovery of a reference to the file system
		final FileSystem fs = FileSystem.get(conf);// 
		if (fs.exists(TMP_DIR)) {
		 fs.delete(TMP_DIR, true);
		}
		if (!fs.mkdirs(inDir)) {
		 throw new IOException("Cannot create input directory " + inDir);
		}

		//*****************************************************************
		//*****  TODO : Define the input files for each map ****
		//*****************************************************************
		
		
		// support: If the input format is SequenceFileInputFormat,
		// To write to files with the format SequenceFile use SequenceFile.writer object
		// Initialize this object for writing the code
		// Writer = SequenceFile.Writer
		// Sequencefile.createWriter (fs, conf, <Path 'file, class> <Key, class> of Value>, CompressionType.NONE)
		// Write the file with writer.append (<key>, <value>)


		// job submission and launch of the platform
		job.waitForCompletion(true);

		//****************************************************************
		//*****  TODO :Retrieve and parse the output files ******
		//****************************************************************

		//****************************************************************************
		//*****           TODO : Calculate and show the value of Pi           ******
		//****************************************************************************
	}	

}

